# Roo Code 3.14 Combined

## Gemini 2.5 Caching is HERE!

*   **Prompt Caching for Gemini Models:** Prompt caching is now available for the `Gemini 1.5 Flash`, `Gemini 2.0 Flash`, and `Gemini 2.5 Pro Preview` models when using the [Requesty](/providers/requesty), [Google Gemini](/providers/gemini), or [OpenRouter](/providers/openrouter) providers (Vertex provider and `Gemini 2.5 Flash Preview` caching coming soon!)
*   **Manual Caching Toggle (Google Gemini & OpenRouter Only):**
    *   For the **[Google Gemini](/providers/gemini)** and **[OpenRouter](/providers/openrouter)** providers specifically, a new checkbox allows you to manually enable prompt caching for supported Gemini 2.5 models.
        <img src="/img/v3.14.2/v3.14.2.png" alt="Prompt Caching Checkbox in Provider Settings" width="600" />
    *   **Why the checkbox?** This setting is provided as a temporary workaround for potential response delays sometimes observed with Google's caching mechanism when accessed via these two providers. Caching is *not* enabled by default for them.
    *   **Requesty:** Caching remains automatic for supported models via Requesty.

## Boomerang Orchestrator Mode

*   Added Boomerang Orchestrator as a built-in mode.
    <img src="/img/v3.14.3/v3.14.3-1.png" alt="Boomerang Orchestrator Mode" width="600" />

## Sexy new minimalist look

*   Improved the home screen user interface for a better initial experience.
    <img src="/img/v3.14.3/v3.14.3.png" alt="New Minimalist Home Screen" width="600" />

## Apply Diff and Other Major File Edit Improvements

*   Improve [`apply_diff`](/advanced-usage/available-tools/apply-diff) to work better with **Google Gemini 2.5** and other models
*   Automatically close files opened by edit tools (`apply_diff`, `insert_content`, `search_and_replace`, `write_to_file`) after changes are approved. This prevents cluttering the editor with files opened by Roo and helps clarify context by only showing files intentionally opened by the user.
*   Added the [`search_and_replace`](/advanced-usage/available-tools/search-and-replace) tool. This tool finds and replaces text within a file using literal strings or regex patterns, optionally within specific line ranges (thanks samhvw8!).
*   Added the [`insert_content`](/advanced-usage/available-tools/insert-content) tool. This tool adds new lines into a file at a specific location or the end, without modifying existing content (thanks samhvw8!).
*   Deprecated the `append_to_file` tool in favor of `insert_content` (use `line: 0`).
*   Correctly revert changes and suggest alternative tools when [`write_to_file`](/advanced-usage/available-tools/write-to-file) fails on a missing line count
*   Better progress indicator for [`apply_diff`](/advanced-usage/available-tools/apply-diff) tools (thanks qdaxb!)
*   Ensure user feedback is added to conversation history even during API errors (thanks System233!).
*   Prevent redundant 'TASK RESUMPTION' prompts from appearing when resuming a task (thanks System233!).
*   Fix issue where error messages sometimes didn't display after cancelling an API request (thanks System233!).

## Terminal Fixes

*   Improved handling of terminal output containing backspace characters for cleaner display (thanks KJ7LNW!).
*   Fix terminal carriage return handling for correct progress bar display (thanks Yikai-Liao!)

## Internationalization: Russian Language Added

*   Added Russian language support (Спасибо asychin!).

## Context Mentions

*   Use material icons for files and folders in mentions (thanks elianiva!)
*   Improvements to icon rendering on Linux (thanks elianiva!)
*   Better handling of `aftercursor` content in context mentions (thanks elianiva!)

<img src="/img/v3.14.0/v3.14.0.png" alt="Context Mentions with Material Icons" width="600" />
## Footgun Prompting

*   **Context Variables:** Added the ability to interpolate context variables (`{{workspace}}`, `{{mode}}`, `{{language}}`, `{{shell}}`, `{{operatingSystem}}`) into custom system prompt override files, allowing for more dynamic prompts (thanks daniel-lxs!). See the [Footgun Prompting documentation](/features/footgun-prompting#using-context-variables) for details.
*   **Override Warning:** Roo Code now displays a warning indicator in the chat input when a system prompt override is active for the current mode.

    <img src="/img/footgun-prompting/footgun-prompting-1.png" alt="Warning indicator for active system prompt override" width="600" />


## MCP Tweaks

*   Support injecting environment variables in MCP config (thanks NamesMT!)
*   Fix MCP hub error when dragging extension to another sidebar
*   Improve display of long MCP tool arguments

## Provider Updates

*   Allow Amazon Bedrock Marketplace ARNs (thanks mlopezr!)
*   Improvements to Requesty model list fetching (thanks dtrugman!)
*   Make the VS Code LM provider show the correct model information (thanks QuinsZouls!)
*   Remove unnecessary calculation from VS Code LM provider (thanks d-oit!)
*   Updated the default model ID for the Unbound provider from `claude-3.5-sonnet` to `claude-3.7-sonnet` (thanks pugazhendhi-m!).

## Bug Fixes and General QOL Improvements and Misc.

*   Make the [`list_files`](/advanced-usage/available-tools/list-files) tool more efficient and smarter about excluding directories like `.git/`
*   Performance improvements to task size calculations, including more efficient token count estimation to reduce gray screens.
*   Give better loading feedback on chat rows (thanks elianiva!)
*   Use a more sensible task export icon
*   Fix file drag and drop on Windows and when using SSH tunnels (thanks NyxJae!)
*   Fix interpolation bug in the “add to context” code action (thanks elianiva!)
*   Fix redundant ‘TASK RESUMPTION’ prompts (thanks System233!)
*   Fix bug opening files when editor has no workspace root
*   Don’t immediately show a model ID error when changing API providers
*   Fixes to make the `focusInput` command more reliable (thanks hongzio!)
*   Track tool use errors in evals
*   Use path aliases in webview source files
*   Better handling of FakeAI “controller” object (thanks wkordalski)
*   Ensure user feedback is added to conversation history even during API errors (thanks System233!).
*   Prevent redundant 'TASK RESUMPTION' prompts from appearing when resuming a task (thanks System233!).
*   Fix issue where error messages sometimes didn't display after cancelling an API request (thanks System233!).
*   Preserve editor state and prevent tab unpinning during diffs (thanks seedlord!)
*   Cleaned up the internal settings data model for better maintainability.
*   Optimized API calls by omitting reasoning parameters for models that do not support reasoning.
*   Corrected word wrapping in Roo message titles (thanks zhangtony239!).
*   Improved clarity in the documentation regarding adding custom settings (thanks shariqriazz!).
